////////////////////////////////////////////////////////////////////////////////
//
// DirFile.h - Direct disk access
// ------------------------------
// Version:   2003-12-27
// Maintain:  Michael Vinther   |   mv@logicnet.dk
//
//
// Last changes:
//
#ifndef DirectFile_H_INCLUDED
#define DirectFile_H_INCLUDED

#include <Windows.h>

typedef DWORD (__stdcall *TStreamGetCallback)(__int64 Offset,char *Buffer,DWORD Count, DWORD ID);

typedef struct {
  HANDLE Handle;
  TStreamGetCallback StreamGet;
  __int64 Position, Offset, Size;

  char *Buffer;
  DWORD BufferPos, BufferSize;
  __int64 BufferOffset; // Only used in stream mode
  DWORD ID; // Only used in stream mode
} TDirectFile;

typedef TDirectFile *PDirectFile;

// Set Size=-1 for auto-detect
PDirectFile DirectFileOpen(char *FileName,__int64 Offset,__int64 Size);
PDirectFile PhysicalDriveOpen(char Drive,__int64 Offset,__int64 Size);
PDirectFile DirectStreamOpen(TStreamGetCallback StreamGetCallback,__int64 Size,int SequentialStream, DWORD ID);

int DirectFileClose(PDirectFile File);
DWORD DirectFileRead(PDirectFile File,char *Buffer,DWORD Count);
__int64 DirectFileSeek(PDirectFile File,__int64 Offset,int Origin);
__int64 DirectFilePosition(PDirectFile File);
__int64 DirectFileSize(PDirectFile File);

#endif