////////////////////////////////////////////////////////////////////////////////
//
// MPEG2Lib.dll project
// --------------------
// Version:   2004-01-10
// Maintain:  Michael Vinther, mv@logicnet.dk
//
// Last changes:
//   OpenMPEG2Stream added


// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the MPEG2LIB_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// MPEG2LIB_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef MPEG2LIB_EXPORTS
#define DLLExport(type) __declspec(dllexport) type __stdcall
#else
#define DLLExport(type) __declspec(dllimport) type __stdcall
#endif

#include <pastypes.h>


//#include <dirfile.h> // Why can't I get TStreamGetCallback from here?
typedef DWORD (__stdcall *TStreamGetCallback)(__int64 Offset,char *Buffer,DWORD Count, DWORD ID);

struct TVideoFrameInfo {
  int Width, Height;
  double FrameRate;
  int AspectRatio; //2004-10-24: Added to get the aspectratio
};

struct TVideoFileInfo {
  int64 Size;
  int64 Position;
  DWORD Frame;
  DWORD VideoPTS;
};


DLLExport(int) OpenMPEG2File(char *FileName,int64 Offset=0,int64 Size=-1);
DLLExport(int) OpenMPEG2Disk(byte Drive,int64 Offset=0,int64 Size=-1);
// If SequentialStream=0 StreamGetCallback must do seeking, if not only sequential reads are performed
DLLExport(int) OpenMPEG2Stream(TStreamGetCallback StreamGetCallback,int SequentialStream,__int64 Size=0x6fffffff,DWORD ID=0);
DLLExport(void) CloseMPEG2File();                                                                       
DLLExport(void) GetMPEG2FrameInfo(TVideoFrameInfo *FrameInfo);
DLLExport(void) GetMPEG2FileInfo(TVideoFileInfo *FileInfo);
DLLExport(void) SetMPEG2PixelFormat(int Format); // See formats in MPEG2Dec.h
DLLExport(pbyte) GetMPEG2Frame();
DLLExport(void) SkipMPEG2Frames(int FrameCount);
DLLExport(void) MPEG2Seek(int64 Position);
DLLExport(void) SetRGBScaleFlag(int DoScaling);
